#define __DEFINE_H

#define	STATIC_SEGMENT		1
#define	CFB_SEGMENT			2
#define	TEXTURE_SEGMENT		3
#define	PICTURE_SEGMENT		4

#define	SCREEN_HT	240
#define	SCREEN_WD	320

#define	STACKSIZE	0x2000

#define	GLIST_LEN	2048

/*---------------------------------------------------------------- */
#ifdef _LANGUAGE_C

typedef struct {
	Mtx modeling;
	Mtx	projection;
	Gfx	glist[GLIST_LEN];
} Dynamic;

extern Dynamic	dynamic;

/* RSP address for the color frame buffer */

extern u16	rsp_cfb[];

/* RSP matrix stack */

extern u64  dram_stack[SP_DRAM_STACK_SIZE64];



#endif	/* _LANGUAGE_C */
