#include <stdio.h>
#include <ctype.h>
#include <stdarg.h>

volatile unsigned *stat= (unsigned *)0xbff08004;
volatile unsigned *wport=(unsigned *)0xbff08000;
volatile unsigned *piok= (unsigned *)0xa4600010;

static void rmonPutchar(char c)
{
    while((*piok & 3)!=0) ;
    while((*stat & 4)==0) ;
    *wport=c;
}


kmc_mon_copy(unsigned *dst)
{
    unsigned *src;
    unsigned ct;

    ct=0x2000/4;
    src=(unsigned *)0xbff00000;
    while(ct){
	*(dst++)=*(src++);
	--ct;
    }
}

void ptstart(void)
{
    int (*fnc)(void);
    unsigned c,c1;
    unsigned *mon;
    unsigned monadr;

    mon=(unsigned *)0xbff00000;
    if(*mon!=0x4b4d4300) return;
    monadr=*(mon+1);
    if(monadr!=0xbff00000){
	kmc_mon_copy((unsigned *)(monadr | 0x20000000));
    }
    (unsigned int *)fnc = monadr+8;
    (*fnc)();
}

/* rmonPrintf function */

/* This is required by Plauger's book for royalty-free usage */
/* Portions of this work are derived from the Standard C Library, */
/* copyright (c) 1992 by P.J. Plauger, published by Prentice-Hall, */
/* and are used with permission. */

static char rmonHoldWord[4];
static char rmonHoldCount = 0;
static int column = 0;

static void *proutPrintf(void *, const char *, int);
static void putchar_n64(char);
static void rmonPutchar(char);

void rmonPrintf(const char *fmt, ...)
{
    va_list ap;

    va_start(ap, fmt);
    _Printf(&proutPrintf, NULL, fmt, ap);
    va_end(ap);
}

static void *proutPrintf(void *str, const char *buf, int n)
{
    int i;
    char c,*p,*q,xbuf[128];

    p=xbuf;
    for(i=0;i<n;++i){
	c=*(buf++);
	switch (c) {
	case '\n':
	    *(p++)='\n';
	    column = 0;
	    break;
	case '\t':
	    do{
		*(p++)=' ';
	    }while(++column % 8);
	    break;
	default:
	    column++;
	    *(p++)=c;
	    break;
	}
	if(c=='\n' || (p-xbuf)>100){
	    rmonPutchar((p-xbuf)-1);
	    q=xbuf;
	    while(q!=p){
		rmonPutchar(*(q++));
	    }
	    p=xbuf;
	}
    }
    if(p!=xbuf){
	rmonPutchar((p-xbuf)-1);
	q=xbuf;
	while(q!=p){
	    rmonPutchar(*(q++));
	}
    }
    return ((void *) 1);   /* return a fake pointer so that it's not NULL */
}

void osSyncPrintf(const char *fmt, ...)
{
    va_list ap;

    va_start(ap, fmt);
    _Printf(&proutPrintf, NULL, fmt, ap);
    va_end(ap);
}
