#define __MENU_C

#include <ultra64.h>
#include "define.h"
#include "static.h"
#include "main.h"
#include "command1.h"
#include "menu.h"

int main_menu_status=0;		/* ᥤ˥塼Υơ */
Menu_window main_menu_window = { 2, 4, 12, EXEC_LAST+2, 200, 0, 255 };

int sub_menu1_status=0;		/* ֥˥塼Υơ (ե̾) */
int	shown_file_num=0;			/*  ɽե */
int	selected_file_num=0;		/*  ե */
Menu_window sub_menu1_window = { 15, 5, 15, 12, 0, 255, 60 };

int sub_menu2_status=0;		/* ֥˥塼Υơ (ǧɥ) */
int	command_confirm=0;			/*  ǧơ */
Menu_window sub_menu2_window = { 22, 15, 19, 4, 200, 20, 20 };

int sub_menu3_status=0;		/* ֥˥塼Υơ (ե륵ɥ) */
s32	file_size;					/*  ե륵 */
Menu_window sub_menu3_window = { 30, 5, 16, 4, 70, 0, 240 };

int sub_menu4_status=0;		/* ֥˥塼Υơ (ɻ楻쥯) */
s32	selected_pict_num=0;		/*  ɻʥС */
Menu_window sub_menu4_window = { 15, 5, 12, 12, 0, 255, 60 };

int sub_menu5_status=0;		/* ֥˥塼Υơ (FAT ɥ쥹ɥ) */
s32	fat_address;					/*  FAT ɥ쥹 */
Menu_window sub_menu5_window = { 30, 5, 21, 4, 70, 0, 220 };

int sub_menu6_status=0;		/* ֥˥塼Υơ (FAT ɽɥ) */
s32	show_fat_address;				/*  FAT ɥ쥹 */
Menu_window sub_menu6_window = { 4, 13, 57, 18, 70, 120, 80 };

int sub_menu7_status=0;		/* ֥˥塼Υơ (visible FAT ɽɥ) */
s32	vfat_address;				/*  visible FAT ɥ쥹 */

int current_menu=MENU_NO_MENU;		/* ߤΥ˥塼( MENU_NO_MENU ϲⳫƤʤ) */

int wait_menu_status=0;
char wait_menu_string[64];

int output_menu_status=0;
char output_menu_string[32];
Menu_window output_menu_window = { 4, 13, TEXT_X+1, TEXT_VIEW_Y+2, 20, 160, 50 };


/*****************************************************************
 *		ץȥ
 */

void set_window_size( int, int, int, int, int, int*, int*, int*, int* );
void proc_menu( int *status, Menu_window mw, int menu_id, void (*draw_func)( int ) );

/****************************************************************
 *		˥塼ɽ
 */
void draw_menu( void ){
	int xx, yy, dx, dy;

	proc_menu( &main_menu_status, main_menu_window, MENU_MAIN_MENU, draw_menu_main );
	proc_menu( &sub_menu1_status, sub_menu1_window, MENU_SUB_MENU1, draw_sub_menu1 );
	proc_menu( &sub_menu2_status, sub_menu2_window, MENU_SUB_MENU2, draw_sub_menu2 );
	proc_menu( &sub_menu3_status, sub_menu3_window, MENU_SUB_MENU3, draw_sub_menu3 );
	proc_menu( &sub_menu4_status, sub_menu4_window, MENU_SUB_MENU4, draw_sub_menu4 );
	proc_menu( &sub_menu5_status, sub_menu5_window, MENU_SUB_MENU5, draw_sub_menu5 );
	proc_menu( &sub_menu6_status, sub_menu6_window, MENU_SUB_MENU6, draw_sub_menu6 );
	proc_menu( &sub_menu7_status, sub_menu6_window, MENU_SUB_MENU7, draw_sub_menu7 );

	if ( wait_menu_status ){
		/* ɽ˥塼(ɥ) */
		gSPDisplayList( glistp++, underchar_dl );
		gDPSetPrimColor( glistp++, 0, 0, 150, 150, 0, 255 );
		set_window_size( wait_menu_status, 90, 60, 160, 24, &xx, &yy, &dx, &dy );
		gSPTextureRectangle( glistp++, xx<<2, yy<<2, (xx+dx)<<2, (yy+dy)<<2, 0, 0, 0, 1<<10, 1<<10 );
		if ( wait_menu_status == 1 ){
			if ( current_menu == MENU_WAIT_MENU )
				draw_wait_menu( 1 );
			else
				draw_wait_menu( 0 );
		}
		if ( wait_menu_status > 1 ) wait_menu_status--;
		if ( wait_menu_status < 0 ) wait_menu_status++;
	}

	proc_menu( &output_menu_status, output_menu_window, MENU_FINISH_MENU, draw_text );


#ifdef A
	if ( output_menu_status ){
		/* ޥɼ¹ǡη̤ɽ˥塼(ɥ) */
		gSPDisplayList( glistp++, underchar_dl );
		gDPSetPrimColor( glistp++, 0, 0, 20, 160, 50, 255 );
		set_window_size( output_menu_status, 20, 96, 280, 123, &xx, &yy, &dx, &dy );
		gSPTextureRectangle( glistp++, xx<<2, yy<<2, (xx+dx)<<2, (yy+dy)<<2, 0, 0, 0, 1<<10, 1<<10 );
		if ( output_menu_status == 1 ){
			draw_text();
		}
		if ( output_menu_status > 1 ) output_menu_status--;
		if ( output_menu_status < 0 ) output_menu_status++;
	}
#endif
}

/*****************************************************************
 *		ɥ
 *		MENU_OPEN_CNT(Ϥ),(MENU_OPEN_CNT-1),...1(Ƥ)
 *		-1(Ĥľ), -2, -3, ...
 */
void set_window_size( int cnt,
					  int xx, int yy, int wx, int wy,
					  int *x, int *y, int *dx, int *dy )
{
	int c;

	c = -cnt;

	if ( ( cnt > MENU_OPEN_CNT ) || ( cnt < MENU_OPEN_CNT ) ){
		*x = *y = *dx = *dy = 0;
	}

	if ( ( cnt == MENU_OPEN_CNT ) || ( cnt == -1 ) ){
		*x = xx + wx/2 - 1;
		*y = yy;
		*dx = 2;
		*dy = wy;
		return;
	}
	if ( ( cnt == MENU_OPEN_CNT-1 ) || ( cnt == -2 ) ){
		*x = xx + wx/2 - 10;
		*y = yy + wy/2 - 1;
		*dx = 20;
		*dy = 2;
		return;
	}

	if ( (cnt <= MENU_OPEN_CNT-2) && (cnt >= 1) ){
		*x = xx;
		*y = yy + (cnt-1)*((wy-4)/((MENU_OPEN_CNT-2)*2));
		*dx = wx;
		*dy = wy - (cnt-1)*((wy-4)/(MENU_OPEN_CNT-2));
		return;
	}

	if ( (c <= MENU_OPEN_CNT) && (c >= 3) ){
		*x = xx;
		*y = yy + (MENU_OPEN_CNT-c)*((wy-4)/((MENU_OPEN_CNT-2)*2));
		*dx = wx;
		*dy = wy - (MENU_OPEN_CNT-c)*((wy-4)/(MENU_OPEN_CNT-2));
		return;
	}

	/*osSyncPrintf( "%d %d %d %d\n", *x, *y, *dx, *dy );*/
}

/*****************************************************************
 *		ɥꥢ
 */
void clean_windows( void )
{
	if ( main_menu_status ) main_menu_status = MENU_CLOSE_CNT;
	if ( sub_menu1_status ) sub_menu1_status = MENU_CLOSE_CNT;
	if ( sub_menu2_status ) sub_menu2_status = MENU_CLOSE_CNT;
	if ( sub_menu3_status ) sub_menu3_status = MENU_CLOSE_CNT;
	if ( sub_menu4_status ) sub_menu4_status = MENU_CLOSE_CNT;
	if ( sub_menu5_status ) sub_menu5_status = MENU_CLOSE_CNT;
	if ( sub_menu6_status ) sub_menu6_status = MENU_CLOSE_CNT;
	if ( sub_menu7_status ) sub_menu7_status = MENU_CLOSE_CNT;

	if ( wait_menu_status ) wait_menu_status = MENU_CLOSE_CNT;
	if ( output_menu_status ) output_menu_status = MENU_CLOSE_CNT;
}

/*****************************************************************
 *		˥塼ν()
 */
void proc_menu( int *status, Menu_window mw, int menu_id, void (*draw_func)( int ) )
{
	int xx, yy, dx, dy;

	if ( *status ){
		/* ᥤ˥塼 */
		gSPDisplayList( glistp++, underchar_dl );
		gDPSetPrimColor( glistp++, 0, 0, mw.r, mw.g, mw.b, 255 );
		set_window_size( *status,  mw.x * 5, mw.y * 7, mw.dx * 5, mw.dy * 7, &xx, &yy, &dx, &dy );
		gSPTextureRectangle( glistp++, xx<<2, yy<<2, (xx+dx)<<2, (yy+dy)<<2, 0, 0, 0, 1<<10, 1<<10 );

		if ( *status == 1 ){
			if ( current_menu == menu_id )
				(*draw_func)( 1 );
			else
				(*draw_func)( 0 );
		}
		if ( *status > 1 ) (*status) --;
		if ( *status < 0 ) (*status) ++;
	}
}
